/*
 *  SignalPerformer.cpp
 *  All
 *
 *  Created by nhn on 10. 12. 22..
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */
#include "StdAfx.h"
#include "EventPerformer.h"

CGTEventPerformer *CGTEventPerformer::sm_pInstance = NULL;
int CGTEventPerformer::sm_nTimerIDMaker = 0;

CGTEventPerformer::CGTEventPerformer(void)
{
	m_performer.InitRunLoopInYourThread();
}

CGTEventPerformer::~CGTEventPerformer(void)
{
	m_performer.RemoveAllSourceAndTimer();
}

CGTEventPerformer * CGTEventPerformer::GetInstance(void)
{
	// DO NOT CARE MULTIPLATFORM..
	if(sm_pInstance == NULL)
		sm_pInstance = new CGTEventPerformer;
	
	return sm_pInstance;
}

void CGTEventPerformer::RegisterSignal(SOURCE_HANDLE handle)
{
	m_performer.AddSource(handle, this, NULL);
}


TIMER_HANDLE CGTEventPerformer::RegisterTimer(TIMER_HANDLE handle, IGTRunLoopTimerEvent* eventHandler, int msec, void* param)
{
	if(handle == 0)
	{
		handle = MakeTimerID();
	}
	
	m_performer.AddTimer(handle, eventHandler, msec/1000., param);
	
	return handle;
}


void CGTEventPerformer::UnRegisterTimer(TIMER_HANDLE handle)
{
	m_performer.RemoveTimer(handle);
}


void CGTEventPerformer::SignalPerform(SOURCE_HANDLE handle, void *arg1, void *arg2)
{
	m_performer.Signal(handle, arg1, arg2);
}


/////////////////////////////////////////////////////////////////////////////////////////////////

void CGTEventPerformer::IGTRunLoopSourceEvent_OnSourcePerform(SOURCE_HANDLE handle, void* param, void* sigParam1, void* sigParam2)
{
	assert(m_pDelegator);
	m_pDelegator->IGTEventPerformerEvents_OnSourcePerform((UINT)handle, (WPARAM)sigParam1, (LPARAM)sigParam2);
}

void CGTEventPerformer::IGTRunLoopTimerEvent_OnTimer(TIMER_HANDLE handle, void* param)
{
	assert(m_pDelegator);
	m_pDelegator->IGTEventPerformerEvents_OnTimerPerform((UINT)handle, param);
}



